.\"	$NetBSD: rl.4,v 1.6 2009/04/11 21:53:01 joerg Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)hk.4	8.1 (Berkeley) 6/5/93
.\"
.Dd April 22, 2000
.Dt RL 4 vax
.Os
.Sh NAME
.Nm rl
.Nd
.Tn RL11 Ns / Tn RL01
and
.Tn RL02
disk interface
.Sh SYNOPSIS
.Cd "rlc0 at uba? csr 0177440"
.Cd "rl0 at rlc0 drive 0"
.Cd "rl* at rlc? drive ?"
.Sh DESCRIPTION
The
.Nm rl
driver
is a typical block-device disk driver; block device
.Tn I/O
is
described in
.Xr physio 4 .
.Pp
The script
.Xr MAKEDEV 8
should be used to create the special files; if a special file
needs to be created by hand consult
.Xr mknod 8 .
.Sh FILES
.Bl -tag -width /dev/rrl[0-7][a-h] -compact
.It Pa /dev/rl[0-7][a-h]
block files
.It Pa /dev/rrl[0-7][a-h]
raw files
.El
.Sh DIAGNOSTICS
.Bl -diag
.It "rl%d: operation incomplete"
The current command to the disk did not complete within the timeout period.
This may be due to hardware failure or a heavily loaded UNIBUS.
.It "rl%d: read data CRC"
The controller detected a CRC error on data read from the disk.
Probably a bad disk pack.
.It "rl%d: header CRC"
The controller detected a CRC error on header data read from the disk.
Probably a bad disk pack.
.It "rl%d: data late"
The controller was not able to transfer data over the bus fast enough to
not overflow/underflow the internal FIFO, probably because a heavily
loaded UNIBUS or mis-ordered UNIBUS devices.
.It "rl%d: header not found"
The requested sector was not found before the timer expired.
If this error is the only error then it may indicate a software bug.
.It "rl%d: non-existent memory"
The controller tried to do DMA to/from a non-mapped address.
This is a software bug.
.It "rl%d: memory parity error"
The host memory data sent had a parity error.
This is a hardware failure.
.El
.Sh SEE ALSO
.Xr hp 4 ,
.Xr uda 4 ,
.Xr up 4 ,
.Xr syslogd 8
.Sh HISTORY
The
.Nm
driver has been around nearly forever.
.Pp
A complete new
.Nm
driver showed up in
.Nx 1.5 .
.Sh BUGS
Error handling is less than optimal.
.Pp
Seeks should be interleaved between multiple disks.
